> ## Documentation Index
> Fetch the complete documentation index at: https://docs.ontime.hosai.app/llms.txt
> Use this file to discover all available pages before exploring further.

# Apply for leave (current employee)

> Apply for leave (current employee)



## OpenAPI

````yaml /api-reference/openapi.json post /api/leave/requests
openapi: 3.1.0
info:
  title: ontime API
  description: APIs for ontime.v2
  version: 1.0.0
servers:
  - url: https://app.ontime.hosai.app
    description: Production
security:
  - apiKey: []
paths:
  /api/leave/requests:
    post:
      tags:
        - Leave
      summary: Apply for leave (current employee)
      description: Apply for leave (current employee)
      operationId: postApiLeaveRequests
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                leaveTypeId:
                  type: string
                  format: uuid
                  pattern: >-
                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                fromDate:
                  type: string
                  pattern: ^\d{4}-\d{2}-\d{2}$
                toDate:
                  type: string
                  pattern: ^\d{4}-\d{2}-\d{2}$
                duration:
                  default: FullDay
                  type: string
                  enum:
                    - FullDay
                    - FirstHalf
                    - SecondHalf
                reason:
                  anyOf:
                    - type: string
                      maxLength: 500
                    - type: 'null'
                backupEmployeeId:
                  anyOf:
                    - type: string
                      format: uuid
                      pattern: >-
                        ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                    - type: 'null'
              required:
                - leaveTypeId
                - fromDate
                - toDate
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  employeeId:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  employeeName:
                    type: string
                  employeeCode:
                    type: string
                  leaveTypeId:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  leaveTypeCode:
                    type: string
                  leaveTypeName:
                    type: string
                  colorTone:
                    type: string
                    enum:
                      - neutral
                      - accent
                      - ok
                      - warn
                      - bad
                      - info
                  fromDate:
                    type: string
                  toDate:
                    type: string
                  duration:
                    type: string
                    enum:
                      - FullDay
                      - FirstHalf
                      - SecondHalf
                  workingDays:
                    type: number
                  reason:
                    anyOf:
                      - type: string
                      - type: 'null'
                  backupEmployeeId:
                    anyOf:
                      - type: string
                        format: uuid
                        pattern: >-
                          ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                      - type: 'null'
                  backupName:
                    anyOf:
                      - type: string
                      - type: 'null'
                  balanceAfter:
                    type: number
                  status:
                    type: string
                    enum:
                      - PendingManager
                      - ManagerApprovedPendingHR
                      - Approved
                      - Rejected
                  requiresHrApproval:
                    type: boolean
                  managerDecisionBy:
                    anyOf:
                      - type: string
                        format: uuid
                        pattern: >-
                          ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                      - type: 'null'
                  managerDecisionName:
                    anyOf:
                      - type: string
                      - type: 'null'
                  managerDecidedAt:
                    anyOf:
                      - type: string
                      - type: 'null'
                  hrDecisionBy:
                    anyOf:
                      - type: string
                        format: uuid
                        pattern: >-
                          ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                      - type: 'null'
                  hrDecisionName:
                    anyOf:
                      - type: string
                      - type: 'null'
                  hrDecidedAt:
                    anyOf:
                      - type: string
                      - type: 'null'
                  decisionNote:
                    anyOf:
                      - type: string
                      - type: 'null'
                  createdAt:
                    type: string
                  timeline:
                    type: array
                    items:
                      type: object
                      properties:
                        key:
                          type: string
                          enum:
                            - submitted
                            - manager
                            - hr
                            - final
                        label:
                          type: string
                        state:
                          type: string
                          enum:
                            - done
                            - current
                            - pending
                            - rejected
                        actorName:
                          anyOf:
                            - type: string
                            - type: 'null'
                        at:
                          anyOf:
                            - type: string
                            - type: 'null'
                        note:
                          anyOf:
                            - type: string
                            - type: 'null'
                      required:
                        - key
                        - label
                        - state
                        - actorName
                        - at
                        - note
                  context:
                    type: object
                    properties:
                      teamSize:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      peakTeamOnLeave:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      peakDeptOnLeave:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      peakOrgOnLeave:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      load:
                        type: string
                        enum:
                          - ok
                          - tight
                          - critical
                      managerName:
                        anyOf:
                          - type: string
                          - type: 'null'
                      priorSameType:
                        type: number
                      days:
                        type: array
                        items:
                          type: object
                          properties:
                            date:
                              type: string
                            weekend:
                              type: boolean
                            team:
                              type: integer
                              minimum: -9007199254740991
                              maximum: 9007199254740991
                            dept:
                              type: integer
                              minimum: -9007199254740991
                              maximum: 9007199254740991
                            org:
                              type: integer
                              minimum: -9007199254740991
                              maximum: 9007199254740991
                          required:
                            - date
                            - weekend
                            - team
                            - dept
                            - org
                    required:
                      - teamSize
                      - peakTeamOnLeave
                      - peakDeptOnLeave
                      - peakOrgOnLeave
                      - load
                      - managerName
                      - priorSameType
                      - days
                required:
                  - id
                  - employeeId
                  - employeeName
                  - employeeCode
                  - leaveTypeId
                  - leaveTypeCode
                  - leaveTypeName
                  - colorTone
                  - fromDate
                  - toDate
                  - duration
                  - workingDays
                  - reason
                  - backupEmployeeId
                  - backupName
                  - balanceAfter
                  - status
                  - requiresHrApproval
                  - managerDecisionBy
                  - managerDecisionName
                  - managerDecidedAt
                  - hrDecisionBy
                  - hrDecisionName
                  - hrDecidedAt
                  - decisionNote
                  - createdAt
                  - timeline
                  - context
components:
  securitySchemes:
    apiKey:
      type: http
      scheme: bearer
      bearerFormat: ont_ API key
      description: >-
        Issue keys in Settings → API. Send them as `Authorization: Bearer ont_…`
        (an `X-Api-Key: ont_…` header is also accepted). Session-cookie routes
        are used by the OnTime web apps and are shown for completeness.

````